Draft BezCurve: Difference between revisions

From FreeCAD Documentation
(More details)
(More information for the properties)
Line 50: Line 50:


<!--T:7-->
<!--T:7-->
* {{PropertyData|Closed}}: Specifies if the Bezier Curve is closed or not
* {{PropertyData|Degree}}: specifies the degree of the Bezier curve or the individual segments.
* {{PropertyData|Closed}}: specifies if the curve is closed or not. If the curve is initially open, this value is {{FALSE}}; setting it to {{TRUE}} will draw a segment to close the curve. If the curve is initially closed, this value is {{TRUE}}; setting it to {{FALSE}} will remove the last segment, and make the curve open.
* {{PropertyData|Degree}}: Specifies the degree of the Bezier Curve (or segments)
* {{PropertyData|Make Face}}: specifies if the curve makes a face or not. If it is {{TRUE}} a face is created, otherwise only the perimeter is considered part of the object. This property only works if {{PropertyData|Closed}} is {{TRUE}}.
* {{PropertyData|Continuity}}: (read-only) when the curve is closed, indicates the continuity of the curve {{incode|[0]}}, or {{incode|[0,0]}}. Otherwise it's {{incode|[]}}.


==Scripting== <!--T:8-->
==Scripting== <!--T:8-->

Revision as of 16:09, 9 November 2018

Draft BezCurve

Menu location
Draft → BezCurve
Workbenches
Draft, Arch
Default shortcut
B Z
Introduced in version
0.14
See also
None

Description

The BezCurve tool creates a Bezier Curve, or a piecewise Bezier curve, from several points in the current work plane. It uses the Draft Linestyle set on the Draft Tray.

How to use

  1. Press the Draft BezCurve button, or press B then Z keys.
  2. Click a first point on the 3D view, or type a coordinate and press the add point button.
  3. Click additional points on the 3D view, or type a coordinate and press the add point button.
  4. Press Esc or the Close button, or double-click the last point to complete the edition.

The object is created as a single Bezier curve of degree number_of_points - 1.

The curve can be transformed to a piecewise wire made of curves of a specified degree by changing its properties.

The control points of the Bezier curve can be edited by double clicking on the element in the tree view, or by pressing the Draft Edit button.

Options

  • Press A or the Finish button to finish the curve, leaving it open.
  • Press O or the Close button to close the curve, that is, a segment will be added from the last point to the first one to form a face. At least four points, a curve of degree three, are required to form a face.
  • Press W or the Wipe button to remove the curve segments already placed, but keep editing the curve from the last point.
  • Press U or the Set WP button to adjust the current working plane in the orientation of the last point.
  • Press X, Y or Z after a point to constrain the next point on the given axis.
  • To enter coordinates manually, simply enter the numbers, then press Enter between each X, Y and Z component.
  • Press R or click the checkbox to toggle relative mode. If relative mode is on, the coordinates of the next point are relative to the last one; if not, they are absolute, taken from the origin (0,0,0).
  • Press T or click the checkbox to toggle continue mode. If continue mode is on, the BezCurve tool will restart after you finish the curve, allowing you to draw another one without pressing the tool button again.
  • Press L or click the checkbox to toggle filled mode. If filled mode is on, a closed wire will create a filled face (DataMake Face true); if not, the closed wire will not make a face (DataMake Face false).
  • Press Ctrl while drawing to force snapping your point to the nearest snap location, independently of the distance.
  • Press Shift while drawing to constrain your next point horizontally or vertically in relation to the last one.
  • Press Ctrl+Z or press the Undo button to undo the last point.
  • Press Esc or the Close button to abort the current command; curve segments already placed will remain.

Properties

  • DataDegree: specifies the degree of the Bezier curve or the individual segments.
  • DataClosed: specifies if the curve is closed or not. If the curve is initially open, this value is false; setting it to true will draw a segment to close the curve. If the curve is initially closed, this value is true; setting it to false will remove the last segment, and make the curve open.
  • DataMake Face: specifies if the curve makes a face or not. If it is true a face is created, otherwise only the perimeter is considered part of the object. This property only works if DataClosed is true.
  • DataContinuity: (read-only) when the curve is closed, indicates the continuity of the curve [0], or [0,0]. Otherwise it's [].

Scripting

The BezCurve tool can by used in macros and from the python console by using the following function:

makeBezCurve(pointslist,[closed],[placement],[support],[degree])
  • Create a Bezier Curve object from the given list of vectors. Instead of a pointslist, you can also pass a Part Wire.

Example:

import FreeCAD,Draft
myFeature = Draft.makeBezCurve(Draft.makeBezCurve(points,False)

Contraining Nodes

The segment endpoints in a piecewise Bezier Curve can be constrained such that adjacent control points are tangent or symmetric to the segments at the endpoint. This is done after object creation using Draft Edit.

  • Sharp - remove constraints
  • Tangent - force adjacent control points to be tangent
  • Symmetric - force adjacent control points to be tangent and equi-distant

Limitations

  • This tool is not available before FreeCAD version 0.14
  • The Points Property does not yet appear in the properties list.
  • OpenCascade does not support Bezier Curve with degree > 25. This should not be a problem in practice.